/*
 * usage.c -- display the rather complicated usage message for the
 *            barrowman program
 *
 * (c) 2005 Dr. Andreas Mueller, Beratung und Entwicklung
 */
#include <usage.h>
#include <stdio.h>

/*
 * usage -- display a usage message for the barrowman program
 */
#define	P(x)	printf(x)
void	usage(const char *progname) {
	printf("usage: %s [ -d ] [ -v ] <section_specification>...\n",
		progname);
	printf("options:\n");
	printf("  -d   turn on debug mode\n");
	printf("  -v   verbose mode: display additional info about the "
		"rocket\n");
P("section specifications have the following formats:\n\n");
P("    nose|cylinder|transition|finsection [ nosetype ] name:value ...\n\n");
P("the nosetype argument is only required for a nosecone section\n");
P("the allowed additional parameters in name:value format depend\n");
P("on the type of section being added. Only the 'length' parameter\n");
P("is required and common to all section types. A cylinder section\n");
P("does not have any parameters except the length.\n\n");
P("Nosecone parameters:\n");
P("valid nosetype strings: conic|ogive|parabolic\n");
P("   diameter    = diameter at base of nosecone\n\n");
P("Transition parameters:\n");
P("   diameter1   = forward diameter\n");
P("   diameter2   = rear diameter\n\n");
P("Finsection parameters: Fins are assumed to be trapzoidal with parallel\n");
P("sides parallel to the axis of the rocket\n");
P("   n           = number of fins\n");
P("   a           = length of fin at airframe\n");
P("   b           = length of fin at outer tip\n");
P("   m           = shear: distance between leading edge at base and at tip\n");
P("                 of fin projected to the axis of the rocket\n");
P("   diameter    = diameter of the fin can\n");
P("   s           = radius of outer tip of fin\n");
P("approximate graphic representation (fin filled with *, airframe with .):\n");
P("                :\n");
P("             diameter\n");
P("           <--------->\n");
P("                :\n");
P("      ^   |.....:.....+        \n");
P("      |   |.....:.....|\\        ^\n");
P("      |   |.....:.....|*\\       |\n");
P("      |   |.....:.....|**\\      |\n");
P("      |   |.....:.....|***\\     |m\n");
P("length|   |.....:....a|****\\    |\n");
P("      |   |.....:.....|*****\\   v\n");
P("      |   |.....:.....|******|\n");
P("      |   |.....:.....|******|b\n");
P("      |   |.....:.....+-__***|\n");
P("      v   |.....:.....|    ^-+\n");
P("                :      \n");
P("                :<---------->\n");
P("                :      s\n");
}
